using Unity.Mathematics;
using Unity.Transforms;
using System.Collections;
using System.Collections.Generic;
using Unity.Entities;
using UnityEngine;

[System.Serializable]
public struct Asteroid : IComponentData
{
	
}
[System.Serializable]
public struct AsteroidConstrained : IComponentData
{
	public bool positionConstrained;
}

[System.Serializable]
public struct AsteroidsNeedsPlacing : IComponentData
{

}
[RequiresEntityConversion]
public class AsteroidAuthoring: MonoBehaviour, IConvertGameObjectToEntity
{
	public bool isConstrained = false;
    public Asteroid asteroid;
	public InitialVelocity initVelocity;
	public void Convert(Entity entity, EntityManager dstManager, GameObjectConversionSystem conversionSystem)
	{
		//if (isConstrained)
		{
			dstManager.AddComponentData<AsteroidConstrained>(entity, new AsteroidConstrained() { positionConstrained = isConstrained });
		}
		dstManager.AddComponentData(entity, asteroid);
		dstManager.AddComponentData(entity, initVelocity);
		dstManager.AddComponentData<AsteroidsNeedsPlacing>(entity, new AsteroidsNeedsPlacing());
    }
}
