﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using Unity.Mathematics;
using Unity.Transforms;
using System.Collections;
using System.Collections.Generic;
using Unity.Entities;
using UnityEngine;
using Unity.Physics;
public class AsteroidSpawning : MonoBehaviour
{
	public GameObject prefabObj;
	public float range;
	public int amount;
	public float initialLinVel = 1.0f;
	public float initialAngVel = 1.0f;
	public float scaleMin = 0.1f;
	public float scaleMax = 2.0f;

	public bool inArc;

	public float arcBegin = 0.0f;
	public float arcEnd = 0.0f;
#if UNITY_EDITOR
	[ContextMenu("Spawn")]
	public void Spawn()
	{
		while(transform.childCount>0)
		{
			var child = transform.GetChild(0);
			GameObject.DestroyImmediate(child.gameObject);
		}
		for(int i=0;i<amount;i++)
		{
			var position = (float2)UnityEngine.Random.insideUnitCircle * range; ;
			if (inArc)
			{
				float2 circleDirection = UnityEngine.Random.insideUnitCircle;
				circleDirection = math.normalize(circleDirection);
				float amount = UnityEngine.Random.Range(arcBegin, arcEnd);
				position = circleDirection * amount;

			}

			var quaternion = UnityEngine.Random.rotation;
			var newObject = (GameObject)UnityEditor.PrefabUtility.InstantiatePrefab(prefabObj);
			newObject.transform.position = transform.position + new Vector3(position.x, 0.0f, position.y);
			newObject.transform.rotation = quaternion;
			newObject.transform.parent = transform;
			newObject.transform.localScale = Vector3.one * Mathf.Lerp(scaleMin, scaleMax, UnityEngine.Random.value);

			var physBody = newObject.GetComponent<Unity.Physics.Authoring.PhysicsBodyAuthoring>();
			var newLinVel = UnityEngine.Random.insideUnitSphere * initialLinVel;
			newLinVel.y = 0.0f;
			physBody.InitialLinearVelocity = newLinVel;
			physBody.InitialAngularVelocity = UnityEngine.Random.insideUnitSphere;
		}
	}

	private void OnDrawGizmosSelected()
	{
		if (inArc)
		{
			UnityEditor.Handles.DrawWireDisc(transform.position, Vector3.up, arcBegin);
			UnityEditor.Handles.DrawWireDisc(transform.position, Vector3.up, arcEnd);
		}
		else
		{
			UnityEditor.Handles.DrawWireDisc(transform.position, Vector3.up, range);
		}
	}
#endif
}
