using Unity.Transforms;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using Unity.Entities;
using Unity.Mathematics;
using Unity.Physics;

[System.Serializable]
public struct InitialVelocity : IComponentData
{
	public float speed;
	public float angularSpeed;
}
public class InitialVelocitySystem : ComponentSystem
{
	protected override void OnUpdate()
	{
		Entities.ForEach((Entity ent, ref InitialVelocity initialVelocity,ref PhysicsVelocity physicsVelocity) =>
		{
			var newSpeed = UnityEngine.Random.insideUnitSphere*initialVelocity.speed;
			newSpeed.y = 0.0f;
			physicsVelocity.Linear = newSpeed;

			var newRot = UnityEngine.Random.insideUnitSphere * initialVelocity.angularSpeed;
			newRot.y = 0.0f;
			physicsVelocity.Angular = newRot;
			PostUpdateCommands.RemoveComponent<InitialVelocity>(ent);

		});
	}
}