using Unity.Entities;
using Unity.Mathematics;
using Unity.Transforms;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using Unity.Scenes;
using Hash128 = Unity.Entities.Hash128;

public class LevelTransition: MonoBehaviour
{
	public Unity.Scenes.SubScene subsceneToEnable;

	[ContextMenu("Enable")]
	public void EnableLevel()
	{
		var em = World.Active.EntityManager;
		var ent = em.CreateEntity();
		em.AddComponentData(ent, new LoadLevelPlease() { sceneGUID = subsceneToEnable.SceneGUID });
	}
}

[System.Serializable]
public struct LoadLevelPlease : IComponentData
{
	public Hash128 sceneGUID;
}
public class SceneLoadSystem : ComponentSystem
{
	protected override void OnUpdate()
	{
		Entities.ForEach((Entity requestEnt, ref LoadLevelPlease please) =>
		{
			var reference = please.sceneGUID;
			Entities.ForEach((Entity ent, ref SceneSectionData sceneReference) =>
			{
				if (sceneReference.SceneGUID == reference)
				{
					Debug.Log("gonna stream in a level");

					PostUpdateCommands.AddComponent<RequestSceneLoaded>(ent, new RequestSceneLoaded() {});

					
				}
			});
			PostUpdateCommands.DestroyEntity(requestEnt);
		});
	}
}