using Unity.Entities;
using Unity.Mathematics;
using Unity.Transforms;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[CreateAssetMenu(fileName = "LevellingData", menuName = "Custom Asset/LevellingData", order = 1)]
public class LevellingData : ScriptableObject
{
	public static LevellingData Inst
	{
		get
		{
			if (_inst == null)
			{
				_inst = Resources.Load<LevellingData>("LevellingData");
			}
			return _inst;
		}
	}
	public float currentScore;
	public static LevellingData _inst;

	[Header("Camera")]
	public AnimationCurve camHeightCurve;

	[Header("movement")]
	public AnimationCurve maxSpeed;
	public AnimationCurve acceleration;
	public AnimationCurve deceleration;

	[Header("Visuals")]
	public AnimationCurve playerScaling;
	public AnimationCurve asteroidDistance;

	[Header("Gathering")]
	public AnimationCurve requiredMass;
	public AnimationCurve trailLength;
}
