using Unity.Mathematics;
using Unity.Transforms;
using System.Collections;
using System.Collections.Generic;
using Unity.Entities;
using UnityEngine;

[System.Serializable]
public struct ParticlePoolRequest : IComponentData
{
	public int particleId;
	public float3 position;
}
[RequiresEntityConversion]
public class ParticlePoolAuthoring : MonoBehaviour
{
	public static ParticlePoolAuthoring Inst;
	public enum Particles
	{
		explode,
		blackHole
	}

	public List<GameObject> particles;

	public void Awake()
	{
		Inst = this;
	}
	public void Spawn(int id, float3 position)
	{
		var prefab = particles[id];
		GameObject.Instantiate(prefab, (Vector3)position+prefab.transform.position, prefab.transform.rotation);
	}
}

public class ParticlePoolSpawning : ComponentSystem
{
	protected override void OnUpdate()
	{
		Entities.ForEach((Entity ent, ref ParticlePoolRequest particleRequest) =>
		{
			ParticlePoolAuthoring.Inst.Spawn(particleRequest.particleId, particleRequest.position);
			PostUpdateCommands.RemoveComponent<ParticlePoolRequest>(ent);
			
		});
	}
}