using Unity.Mathematics;
using Unity.Transforms;
using System.Collections;
using System.Collections.Generic;
using Unity.Entities;
using UnityEngine;
using Unity.Physics;

[System.Serializable]
public struct Orbiting : IComponentData
{
	public float speed;
	public bool once;
	public float3 parentPos;
}
[RequiresEntityConversion]
public class OrbitingAuthoring: MonoBehaviour, IConvertGameObjectToEntity
{
    public Orbiting orbiting;
    public void Convert(Entity entity, EntityManager dstManager, GameObjectConversionSystem conversionSystem)
    {
        dstManager.AddComponentData(entity, orbiting);
    }
}

public class OrbitingSystem : ComponentSystem
{
	protected override void OnUpdate()
	{
		Entities.ForEach((ref Orbiting orbiting,ref Translation trans) =>
		{
			if (orbiting.once)
			{

				var dirToParent = orbiting.parentPos - trans.Value;
				var forwardDir = math.cross(math.normalizesafe(dirToParent), math.up());
				trans.Value += orbiting.speed * Time.DeltaTime * forwardDir;
			}
			else
			{
				orbiting.once = true;
			}

		});
	}
}