using Unity.Transforms;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using Unity.Entities;
using Unity.Mathematics;

public class PlayerLookSystem : ComponentSystem
{
	protected override void OnUpdate()
	{
		Entities.ForEach((ref PlayerMovementData moveData,ref Rotation rotation) =>
		{
			if (math.lengthsq(moveData.currentVelocity) > 0.0f)
			{
				var desiredRot = quaternion.LookRotation(moveData.currentVelocity, math.up()); ;
				rotation.Value = math.slerp(rotation.Value, desiredRot, Time.DeltaTime*moveData.moveRotationSpeed);
			}
		});
	}
}