using Unity.Mathematics;
using Unity.Transforms;
using System.Collections;
using System.Collections.Generic;
using Unity.Entities;
using UnityEngine;

[System.Serializable]
public struct PlayerMovementData : IComponentData
{
	public float maxSpeed;
	public float acceleration;
	public float deceleration;
	public float3 currentVelocity;

	public float moveRotationSpeed;
}

public class PlayerMovementDataUpdateSystem : ComponentSystem
{
	protected override void OnUpdate()
	{
		Entities.ForEach((ref PlayerMovementData movementData, ref PlayerScoring scoring) =>
		{
			movementData.maxSpeed = LevellingData.Inst.maxSpeed.Evaluate(scoring.score);
			movementData.acceleration = LevellingData.Inst.acceleration.Evaluate(scoring.score);
			movementData.deceleration = LevellingData.Inst.deceleration.Evaluate(scoring.score);
		});
	}
}