using Unity.Mathematics;
using Unity.Transforms;
using System.Collections;
using System.Collections.Generic;
using Unity.Entities;
using UnityEngine;

[System.Serializable]
public struct PlayerTransformFollower : IComponentData
{
	
}
[RequiresEntityConversion]
public class PlayerTransformFollowerAuthoring: MonoBehaviour, IConvertGameObjectToEntity
{
    public PlayerTransformFollower playerTransformFollower;
    public void Convert(Entity entity, EntityManager dstManager, GameObjectConversionSystem conversionSystem)
    {
        dstManager.AddComponentData(entity, playerTransformFollower);
    }
}

public class PlayerTransformFollowSystem : ComponentSystem
{
	protected override void OnUpdate()
	{
		Entities.ForEach((ref Player player,ref LocalToWorld localToWorld) =>
		{
			var position = localToWorld.Position;
			var rotation = new quaternion(localToWorld.Value);
			Entities.ForEach((Transform trans, ref PlayerTransformFollower follower) =>
			{
				trans.position = position;
				trans.rotation = rotation;
			});

		});
	}
}