using Unity.Mathematics;
using Unity.Transforms;
using System.Collections;
using System.Collections.Generic;
using Unity.Entities;
using UnityEngine;



[System.Serializable]
public struct SpawnList : IBufferElementData
{
	public Entity ent;
	public int sizeLimit;
	public bool alterSize;
	public bool notGatherable;
}

[System.Serializable]
public struct SpawnListTag :IComponentData
{

}
[RequiresEntityConversion]
public class SpawnListAuthoring: MonoBehaviour, IConvertGameObjectToEntity, IDeclareReferencedPrefabs
{
	public List<GameObject> spawnList;
	public List<SpawnList> spawnListStructs;
    public void Convert(Entity entity, EntityManager dstManager, GameObjectConversionSystem conversionSystem)
    {

		var buff = dstManager.AddBuffer<SpawnList>(entity);
		for(int i=0;i< spawnListStructs.Count;i++)
		{
			var spawnListStruct = spawnListStructs[i];
			spawnListStruct.ent = conversionSystem.GetPrimaryEntity(spawnList[i]);
			buff.Add(spawnListStruct);
		}
		dstManager.AddComponentData<SpawnListTag>(entity, new SpawnListTag());
    }

	public void DeclareReferencedPrefabs(List<GameObject> referencedPrefabs)
	{
		referencedPrefabs.AddRange(spawnList);
	}
}
