using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using Unity.Entities;
using Unity.Jobs;
using Unity.Burst;
using Unity.Mathematics;
using UnityEngine.Jobs;
using Unity.Transforms;
using Unity.Physics;

[System.Serializable]
public struct GatherableAttractor : IComponentData
{
	public float3 attractPosition;
	public double timeInstantiated;
	public int attractionPointId;
	public float mass;

}

public class GatherableAttractorSystem : JobComponentSystem
{
	public struct Job : IJobForEach< GatherableAttractor , PhysicsVelocity, Translation, PhysicsDamping>
	{
		public float deltaTime;
		public void Execute( ref GatherableAttractor gatherableAttractor , ref PhysicsVelocity physicsVelocity, ref Translation translation, ref PhysicsDamping damping)
		{
			damping.Linear = 0.1f;
			var direction = gatherableAttractor.attractPosition - translation.Value;
			physicsVelocity.Linear += direction * deltaTime;

		}
	}
	protected override JobHandle OnUpdate(JobHandle inputDeps)
	{
		Job job = new Job()
		{
			deltaTime = Time.DeltaTime
		};
		return job.Schedule(this, inputDeps);
	}
}
