using Unity.Mathematics;
using Unity.Transforms;
using System.Collections;
using System.Collections.Generic;
using Unity.Entities;
using UnityEngine;

[System.Serializable]
public struct AsteroidPrefab : IComponentData
{
	public Entity Value;
}
[RequiresEntityConversion]
public class RuntimeSpawningAuthoring: MonoBehaviour, IConvertGameObjectToEntity, IDeclareReferencedPrefabs
{
	public GameObject asteroidPrefab;
    public void Convert(Entity entity, EntityManager dstManager, GameObjectConversionSystem conversionSystem)
    {
		dstManager.AddComponentData(entity, new AsteroidPrefab
		{
			Value = conversionSystem.GetPrimaryEntity(asteroidPrefab)
		});
	}

	public void DeclareReferencedPrefabs(List<GameObject> referencedPrefabs)
	{
		referencedPrefabs.Add(asteroidPrefab);
	}
}
