using Unity.Mathematics;
using Unity.Transforms;
using System.Collections;
using System.Collections.Generic;
using Unity.Entities;
using UnityEngine;
using System;

[System.Serializable]
public struct TrailSegment : IComponentData,IComparable<TrailSegment>
{
	public int id;
	public double time;
	public float3 position_WS;
	public float3 previousPosition_WS;


	public int CompareTo(TrailSegment other)
	{
		return id.CompareTo(other.id);
	}
}

[System.Serializable]
public struct TrailLoop : IComponentData
{
	public int startId;
	public int endId;
	public int trailIndex;
}

[System.Serializable]
public struct TrailFinished : IComponentData
{
	public float3 midPoint;
}

[System.Serializable]
public struct TrailLoopPoint : IBufferElementData
{
	public float3 position;
}

[System.Serializable]
public struct TrailLoopTag : IComponentData
{
	
}
[System.Serializable]
public struct TrailLayer : IComponentData
{
	public double lastSpawnTime;
	public float timeBetweenSpawns;
	public float3 lastSpawnPoint;
	public float minDistance;
	public float maxDistance;
}