using Unity.Transforms;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using Unity.Entities;
using Unity.Mathematics;

public class TrailSegmentDestructionSystem : ComponentSystem
{
	protected override void OnUpdate()
	{
		var maxTime = LevellingData.Inst.trailLength.Evaluate(LevellingData.Inst.currentScore);
		Entities.ForEach((Entity entity,ref TrailSegment trailSegment) =>
		{
			if (trailSegment.time+ maxTime < Time.ElapsedTime)
			{
				PostUpdateCommands.RemoveComponent<TrailSegment>(entity);
			}
		});
	}
}